% Konstanten
tol      = 1e-4; % Toleranz
maxlevel = 12;   % Maximale Anzahl Verfeinerungen

% f1
f1 = @(x) (5*sin(20 ./x)).^2 ./(2*x.^3-x.^2);
[Q1,grid1] = adaptsimp(f1,3./2.,4.,tol,maxlevel);
fprintf('Q[f_1] = %17.15f\n',Q1);
clf;
draw(f1,grid1,'(i)');
% print('adaptiv_experience_1.eps','-depsc');
fprintf('Strike any key to continue...\n');
pause;

% f2
f2 = @(x) min(f1(x),1/2);
[Q2,grid2] = adaptsimp(f2,3./2.,4.,tol,maxlevel);
fprintf('Q[f_2] = %17.15f\n',Q2);
clf;
draw(f2,grid2,'(ii)');
% print('adaptiv_experience_2.eps','-depsc');
fprintf('Strike any key to continue...\n');
pause;

% f3
f3 = @(x) 1 ./(1+x.^2);
[Q3,grid3] = adaptsimp(f3,-5.,+5.,tol,maxlevel);
fprintf('Q[f_3] = %17.15f\n',Q3);
clf;
draw(f3,grid3,'(iii)');
% print('adaptiv_experience_3.eps','-depsc');
fprintf('Strike any key to continue...\n');
pause;

% f4
f4 = @(x) sqrt(x);
[Q4,grid4] = adaptsimp(f4,0.,1.,tol,maxlevel);
fprintf('Q[f_4] = %17.15f\n',Q4);
clf;
draw(f4,grid4,'(iv)');
% print('adaptiv_experience_4.eps','-depsc');
fprintf('Strike any key to continue...\n');
pause;

% f5
f5 = @(x) sin(4*pi*x).*exp(-2*x);
[Q5,grid5] = adaptsimp(f5,0.,1.,tol,maxlevel);
fprintf('Q[f_5] = %17.15f\n',Q5);
clf;
draw(f5,grid5,'(v)');
% print('adaptiv_experience_5.eps','-depsc');
fprintf('Strike any key to continue...\n');
pause;

% f6
f6 = @(x) sin(4*pi*x).*exp(-2*x);
[Q6_1,grid6_1] = adaptsimp(f5,0.,0.6,tol,maxlevel);
[Q6_2,grid6_2] = adaptsimp(f5,0.6,1.,tol,maxlevel);
grid6 = [grid6_1,grid6_2];
fprintf('Q[f_6] = %17.15f\n',Q6_1+Q6_2);
clf;
draw(f6,grid6_1,'(vi)');
draw(f6,grid6_2,'(vi)');
% print('adaptiv_experience_6.eps','-depsc');
fprintf('Strike any key to continue...\n');
pause;

% f7
f7 = @(x) (sec(x).^2).*exp(-tan(x).^4);
[Q7,grid7] = adaptsimp(f7,0.,pi/2.,tol,maxlevel);
fprintf('Q[f_7] = %17.15f\n',Q7);
clf;
draw(f7,grid7,'(vii)');
% print('adaptiv_experience_7.eps','-depsc');
fprintf('Strike any key to continue...\n');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function draw(f,grid,titl)
  x = linspace(grid(1),grid(end),1000);
  hold on;
  plot(x,f(x),'-');
  plot(grid,zeros(size(grid)),'+');
  ylim([ylim]+[-0.1,0.1]);
  title(titl);
  xlabel('x');
  ylabel('y');
  box on;
  hold off;
end
